Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1352)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1353)
@@ -1118,32 +1124,32 @@
 
           w_comp    = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp  * (                                            &
-                     ( 37.0 * ibit17 * adv_mom_5                             &
-                  +     7.0 * ibit16 * adv_mom_3                             &
-                  +           ibit15 * adv_mom_1                             &
-                     ) *                                                     &
-                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
-              -      (  8.0 * ibit17 * adv_mom_5                             &
-                  +           ibit16 * adv_mom_3                             &
-                     ) *                                                     &
-                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-              +      (        ibit17 * adv_mom_5                             &
-                     ) *                                                     &
-                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+          flux_t(k) = w_comp  * (                                             &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)  + u(k,j,i)     )                &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                    &
-                     ( 10.0 * ibit17 * adv_mom_5                             &
-                  +     3.0 * ibit16 * adv_mom_3                             &
-                  +           ibit15 * adv_mom_1                             &
-                     ) *                                                     &
-                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
-              -      (  5.0 * ibit17 * adv_mom_5                             &
-                  +           ibit16 * adv_mom_3                             &
-                     ) *                                                     &
-                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-              +      (        ibit17 * adv_mom_5                             &
-                     ) *                                                     &
-                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+          diss_t(k) = - ABS( w_comp ) * (                                     &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
                                          )
 !
@@ -1151,8 +1157,8 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography. 
-          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx      &
-               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy      &
-               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)  &
-                ) * 0.5
+          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx       &
+               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy       &
+               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)   &
+                ) * 0.5_wp
 
           tend(k,j,i) = tend(k,j,i) - (                                       &
@@ -1176,8 +1182,8 @@
            sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                          &
                               + ( flux_r(k) *                                 &
-                                ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
+                                ( u_comp(k) - 2.0_wp * hom(k,1,1,0) )         &
                               / ( u_comp(k) - gu + 1.0E-20_wp   )             &
                               +   diss_r(k) *                                 &
-                                  ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
+                                  ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0) )    &
                               / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
@@ -1193,21 +1199,21 @@
           u_comp(k) = u(k,j,i+1) + u(k,j,i)
           flux_r(k) = ( u_comp(k) - gu ) * (                                  &
-                         37.0 * ( u(k,j,i+1) + u(k,j,i)   )                   &
-                       -  8.0 * ( u(k,j,i+2) + u(k,j,i-1) )                   &
-                       +        ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
+                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                &
+                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                &
+                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
              diss_r(k) = - ABS( u_comp(k) - gu ) * (                          &
-                         10.0 * ( u(k,j,i+1) - u(k,j,i)   )                   &
-                       -  5.0 * ( u(k,j,i+2) - u(k,j,i-1) )                   &
-                       +        ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
+                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                &
+                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                &
+                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
 
              v_comp    = v(k,j+1,i) + v(k,j+1,i-1) - gv
              flux_n(k) = v_comp * (                                           &
-                         37.0 * ( u(k,j+1,i) + u(k,j,i)   )                   &
-                       -  8.0 * ( u(k,j+2,i) + u(k,j-1,i) )                   &
-                       +        ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
+                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                &
+                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                &
+                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
              diss_n(k) = - ABS( v_comp ) * (                                  &
-                         10.0 * ( u(k,j+1,i) - u(k,j,i)   )                   &
-                       -  5.0 * ( u(k,j+2,i) - u(k,j-1,i) )                   &
-                       +        ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
+                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                &
+                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                &
+                       +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
 !
 !--       k index has to be modified near bottom and top, else array
@@ -1222,32 +1228,32 @@
 
           w_comp    = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp  * (                                            &
-                     ( 37.0 * ibit17 * adv_mom_5                             &
-                  +     7.0 * ibit16 * adv_mom_3                             &
-                  +           ibit15 * adv_mom_1                             &
-                     ) *                                                     &
-                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
-              -      (  8.0 * ibit17 * adv_mom_5                             &
-                  +           ibit16 * adv_mom_3                             &
-                     ) *                                                     &
-                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-              +      (        ibit17 * adv_mom_5                             &
-                     ) *                                                     &
-                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
+          flux_t(k) = w_comp  * (                                             &
+                     ( 37.0_wp * ibit17 * adv_mom_5                           &
+                  +     7.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)  + u(k,j,i)     )                &
+              -      (  8.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i) + u(k-1,j,i)   )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) + u(k_mm,j,i) )                &
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                    &
-                     ( 10.0 * ibit17 * adv_mom_5                             &
-                  +     3.0 * ibit16 * adv_mom_3                             &
-                  +           ibit15 * adv_mom_1                             &
-                     ) *                                                     &
-                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
-              -      (  5.0 * ibit17 * adv_mom_5                             &
-                  +           ibit16 * adv_mom_3                             &
-                     ) *                                                     &
-                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-              +      (        ibit17 * adv_mom_5                             &
-                     ) *                                                     &
-                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+          diss_t(k) = - ABS( w_comp ) * (                                     &
+                     ( 10.0_wp * ibit17 * adv_mom_5                           &
+                  +     3.0_wp * ibit16 * adv_mom_3                           &
+                  +              ibit15 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( u(k+1,j,i)   - u(k,j,i)    )                &
+              -      (  5.0_wp * ibit17 * adv_mom_5                           &
+                  +              ibit16 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( u(k_pp,j,i)  - u(k-1,j,i)  )                &
+              +      (           ibit17 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( u(k_ppp,j,i) - u(k_mm,j,i) )                &
                                          )
 !
@@ -1255,8 +1261,8 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx      &
-               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy      &
-               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)  &
-                ) * 0.5
+          div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx       &
+               +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy       &
+               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)   &
+                ) * 0.5_wp
 
           tend(k,j,i) = tend(k,j,i) - (                                       &
@@ -1280,8 +1286,8 @@
            sums_us2_ws_l(k,tn) = sums_us2_ws_l(k,tn)                          &
                               + ( flux_r(k) *                                 &
-                                ( u_comp(k) - 2.0 * hom(k,1,1,0) )            &
-                              / ( u_comp(k) - gu + 1.0E-20_wp   )             &
+                                ( u_comp(k) - 2.0_wp * hom(k,1,1,0)      )    &
+                              / ( u_comp(k) - gu + 1.0E-20_wp          )      &
                               +   diss_r(k) *                                 &
-                                  ABS( u_comp(k) - 2.0 * hom(k,1,1,0) )       &
+                                  ABS( u_comp(k) - 2.0_wp * hom(k,1,1,0) )    &
                               / ( ABS( u_comp(k) - gu ) + 1.0E-20_wp ) )      &
                               *   weight_substep(intermediate_timestep_count)
@@ -1363,6 +1369,6 @@
        REAL(wp), DIMENSION(nzb:nzt+1)  ::  v_comp !:
 
-       gu = 2.0 * u_gtrans
-       gv = 2.0 * v_gtrans
+       gu = 2.0_wp * u_gtrans
+       gv = 2.0_wp * v_gtrans
 
 !       
@@ -1377,32 +1383,32 @@
 
              u_comp           = u(k,j-1,i) + u(k,j,i) - gu
-             flux_l_v(k,j,tn) = u_comp * (                                     &
-                              ( 37.0 * ibit20 * adv_mom_5                      &
-                           +     7.0 * ibit19 * adv_mom_3                      &
-                           +           ibit18 * adv_mom_1                      &
-                              ) *                                              &
-                                     ( v(k,j,i)   + v(k,j,i-1) )               &
-                       -      (  8.0 * ibit20 * adv_mom_5                      &
-                           +           ibit19 * adv_mom_3                      &
-                              ) *                                              &
-                                     ( v(k,j,i+1) + v(k,j,i-2) )               &
-                       +      (        ibit20 * adv_mom_5                      &
-                              ) *                                              &
-                                     ( v(k,j,i+2) + v(k,j,i-3) )               &
+             flux_l_v(k,j,tn) = u_comp * (                                    &
+                              ( 37.0_wp * ibit20 * adv_mom_5                  &
+                           +     7.0_wp * ibit19 * adv_mom_3                  &
+                           +              ibit18 * adv_mom_1                  &
+                              ) *                                             &
+                                        ( v(k,j,i)   + v(k,j,i-1) )           &
+                       -      (  8.0_wp * ibit20 * adv_mom_5                  &
+                           +              ibit19 * adv_mom_3                  &
+                              ) *                                             &
+                                        ( v(k,j,i+1) + v(k,j,i-2) )           &
+                       +      (           ibit20 * adv_mom_5                  &
+                              ) *                                             &
+                                        ( v(k,j,i+2) + v(k,j,i-3) )           &
                                          )
 
-              diss_l_v(k,j,tn) = - ABS( u_comp ) * (                           &
-                              ( 10.0 * ibit20 * adv_mom_5                      &
-                           +     3.0 * ibit19 * adv_mom_3                      &
-                           +           ibit18 * adv_mom_1                      &
-                              ) *                                              &
-                                     ( v(k,j,i)   - v(k,j,i-1) )               &
-                       -      (  5.0 * ibit20 * adv_mom_5                      &
-                           +           ibit19 * adv_mom_3                      &
-                              ) *                                              &
-                                     ( v(k,j,i+1) - v(k,j,i-2) )               &
-                       +      (        ibit20 * adv_mom_5                      &
-                              ) *                                              &
-                                     ( v(k,j,i+2) - v(k,j,i-3) )               &
+              diss_l_v(k,j,tn) = - ABS( u_comp ) * (                          &
+                              ( 10.0_wp * ibit20 * adv_mom_5                  &
+                           +     3.0_wp * ibit19 * adv_mom_3                  &
+                           +              ibit18 * adv_mom_1                  &
+                              ) *                                             &
+                                        ( v(k,j,i)   - v(k,j,i-1) )           &
+                       -      (  5.0_wp * ibit20 * adv_mom_5                  &
+                           +              ibit19 * adv_mom_3                  &
+                              ) *                                             &
+                                        ( v(k,j,i+1) - v(k,j,i-2) )           &
+                       +      (           ibit20 * adv_mom_5                  &
+                              ) *                                             &
+                                        ( v(k,j,i+2) - v(k,j,i-3) )           &
                                                    )
 
@@ -1413,11 +1419,11 @@
              u_comp           = u(k,j-1,i) + u(k,j,i) - gu
              flux_l_v(k,j,tn) = u_comp * (                                    &
-                             37.0 * ( v(k,j,i) + v(k,j,i-1)   )               &
-                           -  8.0 * ( v(k,j,i+1) + v(k,j,i-2) )               &
-                           +        ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
+                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )            &
+                           -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )            &
+                           +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
              diss_l_v(k,j,tn) = - ABS( u_comp ) * (                           &
-                             10.0 * ( v(k,j,i) - v(k,j,i-1)   )               &
-                           -  5.0 * ( v(k,j,i+1) - v(k,j,i-2) )               &
-                           +        ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )            &
+                           -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )            &
+                           +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
 
           ENDDO
@@ -1436,32 +1442,32 @@
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
              flux_s_v(k,tn) = v_comp_l * (                                    &
-                            ( 37.0 * ibit23 * adv_mom_5                       &
-                         +     7.0 * ibit22 * adv_mom_3                       &
-                         +           ibit21 * adv_mom_1                       &
+                            ( 37.0_wp * ibit23 * adv_mom_5                    &
+                         +     7.0_wp * ibit22 * adv_mom_3                    &
+                         +              ibit21 * adv_mom_1                    &
                             ) *                                               &
-                                     ( v(k,j,i)   + v(k,j-1,i) )              &
-                     -      (  8.0 * ibit23 * adv_mom_5                       &
-                         +           ibit22 * adv_mom_3                       &
+                                        ( v(k,j,i)   + v(k,j-1,i) )           &
+                     -      (  8.0_wp * ibit23 * adv_mom_5                    &
+                         +              ibit22 * adv_mom_3                    &
                             ) *                                               &
-                                     ( v(k,j+1,i) + v(k,j-2,i) )              &
-                     +      (        ibit23 * adv_mom_5                       &
+                                        ( v(k,j+1,i) + v(k,j-2,i) )           &
+                     +      (           ibit23 * adv_mom_5                    &
                             ) *                                               &
-                                     ( v(k,j+2,i) + v(k,j-3,i) )              &
+                                        ( v(k,j+2,i) + v(k,j-3,i) )           &
                                          )
 
              diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
-                            ( 10.0 * ibit23 * adv_mom_5                       &
-                         +     3.0 * ibit22 * adv_mom_3                       &
-                         +           ibit21 * adv_mom_1                       &
+                            ( 10.0_wp * ibit23 * adv_mom_5                    &
+                         +     3.0_wp * ibit22 * adv_mom_3                    &
+                         +              ibit21 * adv_mom_1                    &
                             ) *                                               &
-                                     ( v(k,j,i)   - v(k,j-1,i) )              &
-                     -      (  5.0 * ibit23 * adv_mom_5                       &
-                         +           ibit22 * adv_mom_3                       &
+                                        ( v(k,j,i)   - v(k,j-1,i) )           &
+                     -      (  5.0_wp * ibit23 * adv_mom_5                    &
+                         +              ibit22 * adv_mom_3                    &
                             ) *                                               &
-                                     ( v(k,j+1,i) - v(k,j-2,i) )              &
-                     +      (        ibit23 * adv_mom_5                       &
+                                        ( v(k,j+1,i) - v(k,j-2,i) )           &
+                     +      (           ibit23 * adv_mom_5                    &
                             ) *                                               &
-                                     ( v(k,j+2,i) - v(k,j-3,i) )              &
-                                                 )
+                                        ( v(k,j+2,i) - v(k,j-3,i) )           &
+                                                  )
 
           ENDDO
@@ -1471,11 +1477,11 @@
              v_comp_l       = v(k,j,i) + v(k,j-1,i) - gv
              flux_s_v(k,tn) = v_comp_l * (                                    &
-                           37.0 * ( v(k,j,i) + v(k,j-1,i)   )                 &
-                         -  8.0 * ( v(k,j+1,i) + v(k,j-2,i) )                 &
-                         +        ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )              &
+                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )              &
+                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
              diss_s_v(k,tn) = - ABS( v_comp_l ) * (                           &
-                           10.0 * ( v(k,j,i) - v(k,j-1,i)   )                 &
-                         -  5.0 * ( v(k,j+1,i) - v(k,j-2,i) )                 &
-                         +        ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )              &
+                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )              &
+                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
 
           ENDDO
@@ -1483,8 +1489,8 @@
        ENDIF
 
-       flux_t(0) = 0.0
-       diss_t(0) = 0.0
-       flux_d    = 0.0
-       diss_d    = 0.0
+       flux_t(0) = 0.0_wp
+       diss_t(0) = 0.0_wp
+       flux_d    = 0.0_wp
+       diss_d    = 0.0_wp
 !
 !--    Now compute the fluxes and tendency terms for the horizontal and
@@ -1497,32 +1503,32 @@
  
           u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp * (                                             &
-                     ( 37.0 * ibit20 * adv_mom_5                             &
-                  +     7.0 * ibit19 * adv_mom_3                             &
-                  +           ibit18 * adv_mom_1                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+1) + v(k,j,i)   )                 &
-              -      (  8.0 * ibit20 * adv_mom_5                             &
-                  +           ibit19 * adv_mom_3                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+2) + v(k,j,i-1) )                 &
-              +      (        ibit20 * adv_mom_5                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+3) + v(k,j,i-2) )                 &
+          flux_r(k) = u_comp * (                                              &
+                     ( 37.0_wp * ibit20 * adv_mom_5                           &
+                  +     7.0_wp * ibit19 * adv_mom_3                           &
+                  +              ibit18 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+1) + v(k,j,i)   )               &
+              -      (  8.0_wp * ibit20 * adv_mom_5                           &
+                  +              ibit19 * adv_mom_3                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+2) + v(k,j,i-1) )               &
+              +      (           ibit20 * adv_mom_5                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+3) + v(k,j,i-2) )               &
                                )
 
-          diss_r(k) = - ABS( u_comp ) * (                                    &
-                     ( 10.0 * ibit20 * adv_mom_5                             &
-                  +     3.0 * ibit19 * adv_mom_3                             &
-                  +           ibit18 * adv_mom_1                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+1) - v(k,j,i)  )                  &
-              -      (  5.0 * ibit20 * adv_mom_5                             &
-                  +           ibit19 * adv_mom_3                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+2) - v(k,j,i-1) )                 &
-              +      (        ibit20 * adv_mom_5                             &
-                     ) *                                                     &
-                                 ( v(k,j,i+3) - v(k,j,i-2) )                 &
+          diss_r(k) = - ABS( u_comp ) * (                                     &
+                     ( 10.0_wp * ibit20 * adv_mom_5                           &
+                  +     3.0_wp * ibit19 * adv_mom_3                           &
+                  +              ibit18 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+1) - v(k,j,i)  )                &
+              -      (  5.0_wp * ibit20 * adv_mom_5                           &
+                  +              ibit19 * adv_mom_3                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+2) - v(k,j,i-1) )               &
+              +      (           ibit20 * adv_mom_5                           &
+                     ) *                                                      &
+                                    ( v(k,j,i+3) - v(k,j,i-2) )               &
                                         )
 
